function parseMd(content) {
    //var frontMatters = [];
    var blockCount;
    var preDataIndex;
    var parseBlockDiv;
    var preImgObject = { 'image': {} };
    var isNotFrontMatterCount = 0;
    var isAmpImgRange = false;
    var result = [];

    var blocks = new Array();
    lineIdx = 1;
    foundImg = false;
    crossLine = "";

    for (const line of content.split('\n')) {
        lineIdx++;
        if (isNotFrontMatterCount < 2) {
            frontMatters.push(line)
            if (line.includes('---')) {
                isNotFrontMatterCount += 1;
            }
            continue;
        }

/*         if (line.toString().trim() == "") {
            blocks.push({ 'type': 'br', 'text': line });
            continue;
        } */

        if (line.includes('###')) {
            blocks.push({ 'type': 'title', 'text': line });
            continue;
        }

        if (line.includes('{{% chuz-div class=\"mt-5\" %}}')) {
            blocks.push({ 'type': 'mt5', 'text': line });
            continue;
        }

        if (line.includes('<amp-img') || foundImg) {
            crossLine += line;
            foundImg = true;
            if (line.includes('</amp-img>'))
            {
                blocks.push({ 'type': 'img', 'text': crossLine });
                foundImg = false;
                crossLine = "";
            }
            continue;
        }

        blocks.push({ 'type': 'para', 'text': line });
    }
    
    return blocks
}

const parseTitle = line => {
    var title = '';
    title = line.replace('### **', '');
    title = title.replace('**', '');
    if (title.includes('敘述')) {
        title = title.replace('<!-- ', '');
        title = title.replace('-->', '');
    }
    return title;
};

const parseAmpImg = line => {
    if (line.includes('alt')) {
        const altParameter = line.replace(/ |alt=|"/g, '');
        return { alt: altParameter };
    } else if (line.includes('src')) {
        const srcParameter = line.replace(/ |src=|"/g, '');
        return { src: srcParameter };
    } else if (line.includes('height')) {
        const heightParameter = line.replace(/ |height=|"/g, '');
        return { height: heightParameter };
    } else if (line.includes('width')) {
        const widthParameter = line.replace(/ |width=|"/g, '');
        return { width: widthParameter };
    } else if (line.includes('layout')) {
        const layoutParameter = line.replace(/ |layout=|"|>/g, '');
    }
}
